using System;

/// @author Omanimi
/// @version 16.10.2023
/// <summary>
/// 
/// </summary>
public class MjPilkkominen
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main()
    {
        char[] erottimet = new char[] { ' ', ';', ',' };
        Console.Write("Erotinmerkit ovat: ");
        foreach (char merkki in erottimet)
        {
            Console.Write($"'{merkki}' ");
        }
        Console.WriteLine();
        Console.Write("Kirjoita jono jossa sanoja > ");
        string mj = Console.ReadLine();

        // Split()-metodin avulla saadaan tehtya merkkijonosta
        // merkkijonotaulukko. Split ottaa parametrina merkkitaulukon
        // jossa erotinmerkit on ilmoitettu.
        // String[] pilkottu = mj.Split(erottimet, StringSplitOptions.RemoveEmptyEntries);
        string[] pilkottu = mj.Split(erottimet);
        TulostaPalat(pilkottu);  
        
        Console.Write("Anna kokonaislukuja > ");
        string lukusyote = Console.ReadLine();

        int[] luvut = MerkkijonoLuvuiksi(lukusyote, erottimet);
        if ( luvut != null )
            Console.WriteLine("Antamiesi lukujen summa on : " + Summa(luvut));
        else
            Console.WriteLine("Annoit jotain muuta kuin lukuja, tai tyhjan merkkijonon");
        
    }

    
    /// <summary>
    /// Aliohjelma muuttaa annetun merkkijonon kokonaislukutaulukoksi
    /// siten, etta eri luvut erotellaan annetun merkkitaulukon (erotinmerkkien)
    /// perusteella. Alkuperäisen syötteen alusta ja lopusta poistetaan välilyönnit.
    /// </summary>
    /// <param name="lukusyote">Muunnettava merkkijono</param>
    /// <param name="erottimet">Sallitut erotinmerkit merkkitaulukossa</param>
    /// <returns>Merkkijonosta selvitetty kokonaislukutaulukko. null jos yksikin luku väärin</returns>
    /// <example>
    /// <pre name="test">
    ///    int[] t1 = MerkkijonoLuvuiksi("1 2 3", new char[] {' '});
    ///    String.Join(" ", t1) === "1 2 3";
    ///    t1 === new int[]{1,2,3};
    ///    int[] t2 = MerkkijonoLuvuiksi(" ,,1;;3  ;5  ", new char[] {' ', ',', ';'});
    ///    t2 =J= "0, 0, 1, 0, 3, 0, 0, 5";
    ///    MerkkijonoLuvuiksi("1;;3  ;5", new char[] {' ', ',', ';'}) =J= "1, 0, 3, 0, 0, 5";
    ///    MerkkijonoLuvuiksi("1 3k 5", new char[] {' '}) === null;
    /// </pre>
    /// </example>
    public static int[] MerkkijonoLuvuiksi(string lukusyote, char[] erottimet)
    {
        // Tyhjat pois edesta ja lopusta (Trim())            
        string[] pilkottu = lukusyote.Trim().Split(erottimet);
        int[] luvut = new int[pilkottu.Length]; // luvut[] saa kookseen saman kuin pilkottu[]
        for (int i = 0; i < pilkottu.Length; i++)
        {
            string jono = pilkottu[i];
            if (!string.IsNullOrEmpty(jono))
            {
                if (!int.TryParse(jono, out luvut[i])) return null;
            }
        }

        return luvut;
    }

    
    /// <summary>
    /// Laskee kokonaislukutaulukon alkiot yhteen ja palauttaa alkioiden summan.
    /// </summary>
    /// <param name="luvut">Tutkittava kokonaislukutaulukko</param>
    /// <returns>Taulukon alkioiden summa</returns>
    /// <example>
    /// <pre name="test">
    ///    Summa(new int[]{1,2,3}) === 6;
    ///    Summa(new int[]{2}) === 2;
    /// </pre>
    /// </example>
    public static int Summa(int[] luvut)
    {
        int summa = 0;
        foreach (int luku in luvut) 
            summa += luku;
        return summa;
    }
    
    
    /// <summary>
    /// Tulostetaan merkkijonotaulukon palat
    /// </summary>
    /// <param name="palat">Tulostettava merkkijonotaulukko</param>
    public static void TulostaPalat(string[] palat)
    {
        foreach (string pala in palat)
            Console.WriteLine($"Pala: \"{pala}\"");
        Console.WriteLine("-------------------------------");
    }
    
    
}